<?php
    /*
        RStack云平台，复制请保留版权：http://www.rstack.com.cn/
        update:2022-05-18
    */
  
    define('virtualType', 'kvm');
    define('moduleName', 'rstackKVM');

	if(!function_exists('vlang_vars_name')){
		function vlang_vars_name($str, $array){

			foreach($array as $k => $v){

				$str = str_replace('{{'.$k.'}}', $v, $str);

			}
			return $str;
		}
	}

	//创建云服务器
	function rstackKVM_CreateAccount($params){
		 $userid = $params["userid"];
		 
		 $hostname = $params["domain"]; 
		 $vpsPassword = $params["password"];
		 //初始化判断是否免费的套餐
		 $query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc");
		 $res = mysql_fetch_array($query);
		 $area_id = $params['configoptions']['Area ID'] ? $params['configoptions']['Area ID'] : $params["configoption1"];
		 $node_id= $params['configoptions']['Node ID'] ? $params['configoptions']['Node ID'] : $params["configoption2"];
		 $os_id = $params['configoptions']['OS ID'] ? $params['configoptions']['OS ID'] : $params["configoption3"];
		 $cpu = $params['configoptions']['Cpu'] ? $params['configoptions']['Cpu'] : $params["configoption4"];
		 $cpu_limit = $params['configoptions']['Cpu Limit'] ? $params['configoptions']['Cpu Limit'] : $params["configoption5"];
		 $cpu_mode = $params["configoption6"];
		 $ram = $params['configoptions']['Ram'] ? $params['configoptions']['Ram'] : $params["configoption7"];
		 $disk = $params['configoptions']['Disk'] ? $params['configoptions']['Disk'] : $params["configoption8"];
		 $port = $params['configoptions']["Port"] ? $params['configoptions']['Port'] : $params["configoption9"];
		 $ports = $params['configoptions']['Ports'] ? $params['configoptions']['Ports'] : $params["configoption10"];
		 $bwlimit = $params['configoptions']['Bwlimit'] ? $params['configoptions']['Bwlimit'] : $params["configoption11"]; //单位GB  为0不限制流量
		 $ip = $params['configoptions']['IP Number'] ? $params['configoptions']['IP Number'] : $params["configoption12"]; //IP数量,如共享IP必须设1
		 $portmap = $params['configoptions']['Portmap'] ? $params['configoptions']['Portmap'] : $params["configoption13"]; 
		 $binding_domain = $params['configoptions']['Binding Domain'] ? $params['configoptions']['Binding Domain'] : $params["configoption14"]; 
		 //$rvlimit = $params['configoptions']['Rvlimit'] ? $params['configoptions']['Rvlimit'] : $params["configoption15"];
		 $backup_snapshot = $params['configoptions']['Backup Snapshot'] ? $params['configoptions']['Backup Snapshot'] : $params["configoption15"];
		 $backup_full = $params['configoptions']['Backupfull'] ? $params['configoptions']['Backupfull'] : $params["configoption16"];
		 $random_ip = $params["configoption17"];
		 $iptype = $params['configoptions']['Iptype'] ? $params['configoptions']['Iptype'] : $params["configoption18"]; //混合云（0=开公网IP主机  2=开内网IP主机 0=按全部节点可用IP池）
		 $ipv6 = $params['configoptions']['Ipv6 Number'] ? $params['configoptions']['Ipv6 Number'] : $params["configoption19"]; 
		 $remote_port = $params["configoption20"];
		 $disk_sys_iops = $params["configoption21"];
		 $disk_data_iops = $params["configoption22"];
		 $systemdisk = $params['configoptions']['SystemDisk'] ? $params['configoptions']['SystemDisk'] : $params["configoption23"];
		 //判断是否免费
		if($res["nextinvoicedate"]=='0000-00-00'){
			$res["nextinvoicedate"]='2099-01-01';
		}
		
		//获取用户信息注册RSTACK
		$query2 = mysql_query("SELECT * FROM `tblusers` WHERE id = ".$userid);
		$res2 = mysql_fetch_array($query2);
		
		//查询用户是否存在否则就创建
		$param = rstackKVM_sign($params["serveraccesshash"]);
		$url = "http://".$params["serverhostname"]."/api/v3";
		$header = array();
		$data = array(
		    "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
            "api_type"=>$param["api_type"],
            "action"=>"user_info",
          	"userid"=>$userid
		);
		$rsret = rstackKVM_post($url,$header,$data);
	
	
		if ($rsret ==""){
			$param = rstackKVM_sign($params["serveraccesshash"]);
			$url = "http://".$params["serverhostname"]."/api/v3";
			$header = array();
			$data = array(
			    "api_sign"=>$param["api_sign"],
                "api_random"=>$param["api_random"],
                "api_timestamp"=>$param["api_timestamp"],
                "api_type"=>$param["api_type"],
    			"action"=>"user_add",
				"userid"=>$userid,
				"username"=>"whmcs".$userid,
				"password"=>$res2["password"],
				"email"=>$res2["email"],
				"remark"=>"WHMCS CREATE USERS"
			);
			$rsret = rstackKVM_post($url,$header,$data);
			$ret = rstackKVM_CheckReturn($rsret);
			if ($ret["code"]=="-1"){
				return array('success' => $ret["msg"]);
			}
		}

		$param = rstackKVM_sign($params["serveraccesshash"]);
		$url = "http://".$params["serverhostname"]."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
            "api_type"=>$param["api_type"],
			"action"=>"kvm_create",
			"userid"=>$userid,
			"areaid"=>$area_id,
			"nodeid"=>$node_id,
			"cpu"=>$cpu,
			"cpu_limit"=>$cpu_limit,
			"cpu_mode"=>$cpu_mode,
			"ram"=>$ram,
			"disk"=>$disk,
			"disk_sys_iops"=>$disk_sys_iops,
			"disk_data_iops"=>$disk_data_iops,
			"disk_sys_mode"=>"writeback",
			"disk_data_mode"=>"writeback",
			"port"=>$port,
			"ports"=>$ports,
			"bwlimit"=>$bwlimit,
			"ip"=>$ip,
			"ipv6"=>$ipv6,
			"backup_snapshot"=>$backup_snapshot,
			"backup_full"=>$backup_full,
			"portmap"=>$portmap,
			"binding_domain"=>$binding_domain,
			"osid"=>$os_id,
			"vmname"=>$hostname,
			"iprandom"=>$random_ip,
			"vmpass"=>$vpsPassword,
			"vncpass"=>$vpsPassword,
			"iptype"=>$iptype,
			"remote_port"=>$remote_port,
			"systemdisk"=>$systemdisk,
			"remark"=>"RSTACK WHMCS CREATE",
			"returnjson"=>"1"
        );
		$rsret = rstackKVM_post($url,$header,$data);
		$ret = rstackKVM_CheckReturn($rsret);
		if ($ret["code"]=="0") {
			$query = mysql_query("SELECT id FROM tblhosting WHERE domain ='$hostname' order by id asc");
            $res = mysql_fetch_array($query);
			$datas = json_decode($ret["msg"]);
			$ip = $datas->ip;
			$additionals_ip = $datas->additionals_ip;
			$vmid = $datas->id; 
			//dedicatedip=主IP  assignedips = 类似附属备注IP
			update_query("tblhosting",array("dedicatedip"=>$ip,"assignedips"=>$additionals_ip,"subscriptionid"=>$vmid),array("id"=> $res["id"]));
			//更新订单，原WHMCS需要人工再次确认审核 才会激活，实际主机已开通了。如果不想手工在审核下 把注释去掉即可
			//update_query("tblorders",array("status"=>"Active"),array("id"=> $res["orderid"]));
			return 'success';
		} else {
			return array('error' => $ret["msg"]);
		}
	}
	
	
	//续费。
	function rstackKVM_Renew($params){
		//查询API主机ID
		$hostname=$params["domain"];
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
	
		$vminfo = rstackKVM_CheckReturn(rstackKVM_search_virtual($params["serverhostname"], $params["serveraccesshash"],$res["subscriptionid"]));
		if ($vminfo["code"]=="-1"){
		    return array('error' => $ret["msg"]);
		}
		//$virtuals = json_decode($vminfo["msg"])
		if ($vminfo["code"] != "running"){
			//如果主机未运行，可能已过期，需先修改API主机状态为运行
			$ret = rstackKVM_CheckReturn(rstackKVM_reset_virtual_status($params["serverhostname"], $params["serveraccesshash"],$res["subscriptionid"],"2"));
			if ($ret["code"]=="-1"){
				return array('error' => $ret["msg"]);
			}
			//启动主机
			$ret = rstackKVM_CheckReturn(rstackKVM_start_virtual($params["serverhostname"], $params["serveraccesshash"],$res["subscriptionid"]));
			if ($ret["code"]=="-1"){
				return array('error' => $ret["msg"]);
			}
			return 'success';
		}else{
			//执行开机，若已开机，则直接返回成功
			$ret = rstackKVM_CheckReturn(rstackKVM_start_virtual($params["serverhostname"], $params["serveraccesshash"],$res["subscriptionid"]));
			if ($ret["code"]=="-1"){
				return array('error' => $ret["msg"]);
			}
			return 'success';
		}
 	 }
	 
	  //过期续费 与 开机。 【模块名：解除暂停】
	function rstackKVM_UnsuspendAccount($params){
		 $hostname=$params["domain"];
		 $query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc ");
		 $res = mysql_fetch_array($query);
		 $cpu = $params['configoptions']['Cpu'] ? $params['configoptions']['Cpu'] : $params["configoption4"];
		 $cpu_limit = $params['configoptions']['Cpu Limit'] ? $params['configoptions']['Cpu Limit'] : $params["configoption5"];
		 $cpu_mode = $params["configoption6"];
		 $ram = $params['configoptions']['Ram'] ? $params['configoptions']['Ram'] : $params["configoption7"];
		 $disk = $params['configoptions']['Disk'] ? $params['configoptions']['Disk'] : $params["configoption8"];
		 $port = $params['configoptions']['Port'] ? $params['configoptions']['Port'] : $params["configoption9"];
		 $ports = $params['configoptions']['Ports'] ? $params['configoptions']['Ports'] : $params["configoption10"];
		 $bwlimit = $params['configoptions']['Bwlimit'] ? $params['configoptions']['Bwlimit'] : $params["configoption11"]; //单位GB  为0不限制流量
		 //$ip = $params['configoptions']['IP'] ? $params['configoptions']['IP'] : $params["configoption12"]; //IP数量,如共享IP必须设1
		 $portmap = $params['configoptions']['Portmap'] ? $params['configoptions']['Portmap'] : $params["configoption13"]; 
		 $binding_domain = $params['configoptions']['Binding Domain'] ? $params['configoptions']['Binding Domain'] : $params["configoption14"]; 
		 //$rvlimit = $params['configoptions']['Rvlimit'] ? $params['configoptions']['Rvlimit'] : $params["configoption15"];
		 $backup_snapshot = $params['configoptions']['Backup Snapshot'] ? $params['configoptions']['Backup Snapshot'] : $params["configoption15"];
		 $backup_full = $params['configoptions']['Backupfull'] ? $params['configoptions']['Backupfull'] : $params["configoption16"];
		 $systemdisk = $params['configoptions']['SystemDisk'] ? $params['configoptions']['SystemDisk'] : $params["configoption23"];
		 //判断是否免费
		if($res["nextinvoicedate"]=='0000-00-00'){
			$res["nextinvoicedate"]='2099-01-01';
		}
		$status = "2"; 
  
		$rsret = rstackKVM_edit_host($params["serverhostname"], $params["serveraccesshash"],$hostname,$cpu,$cpu_limit,$cpu_mode,$ram,$disk,$port,$ports,$bwlimit,$portmap,$binding_domain,$backup_snapshot,$backup_full,$status,$systemdisk);
		$ret = rstackKVM_CheckReturn($rsret);
		if ($ret["code"]=="0") {
			$rets = rstackKVM_CheckReturn(rstackKVM_start_virtual($params["serverhostname"], $params["serveraccesshash"], $res["subscriptionid"]));
			if ($rets["code"]=="-1"){
				return array('error' => $rets["msg"]);
			}
			return 'success';
		}else{
			return array('error' => $ret["msg"]);
		}
 	 }
	 
	//暂停主机
	function rstackKVM_SuspendAccount($params){
		$hostname=$params["domain"];
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
		
		$param = rstackKVM_sign($params["serveraccesshash"]);
		$url = "http://".$params["serverhostname"]."/api/v3";
		$header = array();
		$data = array(
		    "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_force_stop", //默认强制关机，如果需要软关机 存kvm_stop（软不一定能关闭）
            "vmid"=>$res["subscriptionid"]
        );
		$rsret = rstackKVM_post($url,$header,$data);
		$ret = rstackKVM_CheckReturn($rsret);
		if ($ret["code"]=="0") {
			//如果关闭成功，API状态更改为中止。
			$ret = rstackKVM_CheckReturn(rstackKVM_reset_virtual_status($params["serverhostname"], $params["serveraccesshash"],$res["subscriptionid"],"1"));
			if ($ret["code"]=="-1"){
				return array('success' => $ret["msg"]);
			}
			return 'success';
		}else{
			return array('success' => $ret["msg"]);
		}
	}
	
	//删除主机
	function rstackKVM_TerminateAccount($params){
		$hostname = $params["domain"];
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
		$param = rstackKVM_sign($params["serveraccesshash"]);
		$url = "http://".$params["serverhostname"]."/api/v3";
		$header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
            "vmid"=>$res["subscriptionid"],
            "action"=>"kvm_delete",
			"forcedelete"=>"0" //如果为1强制删除
        );
        $rsret = rstackKVM_post($url,$header,$data);
		$ret = rstackKVM_CheckReturn($rsret);
		if ($ret["code"]=="0") {
			//删除成功，将订单状态更改为取消。
			$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc");
            $res = mysql_fetch_array($query);
			update_query("tblorders",array("status"=>"Cancelled"),array("id"=> $res["orderid"]));
			return 'success';
		}else{
			return array('success' => $ret["msg"]);
		}
	}
	
	//升级套餐
	 function rstackKVM_ChangePackage($params){
		 $hostname=$params["domain"];
		 $query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc ");
		 $res = mysql_fetch_array($query);
		 $cpu = $params['configoptions']['Cpu'] ? $params['configoptions']['Cpu'] : $params["configoption4"];
		 $cpu_limit = $params['configoptions']['Cpu Limit'] ? $params['configoptions']['Cpu Limit'] : $params["configoption5"];
		 $cpu_mode = $params["configoption6"];
		 $ram = $params['configoptions']['Ram'] ? $params['configoptions']['Ram'] : $params["configoption7"];
		 $disk = $params['configoptions']['Disk'] ? $params['configoptions']['Disk'] : $params["configoption8"];
		 $port = $params['configoptions']['Port'] ? $params['configoptions']['Port'] : $params["configoption9"];
		 $ports = $params['configoptions']['Ports'] ? $params['configoptions']['Ports'] : $params["configoption10"];
		 $bwlimit = $params['configoptions']['Bwlimit'] ? $params['configoptions']['Bwlimit'] : $params["configoption11"]; //单位GB  为0不限制流量
		 //$ip = $params['configoptions']['IP'] ? $params['configoptions']['IP'] : $params["configoption12"]; //IP数量,如共享IP必须设1
		 $portmap = $params['configoptions']['Portmap'] ? $params['configoptions']['Portmap'] : $params["configoption13"]; 
		 $binding_domain = $params['configoptions']['Binding Domain'] ? $params['configoptions']['Binding Domain'] : $params["configoption14"]; 
		 //$rvlimit = $params['configoptions']['Rvlimit'] ? $params['configoptions']['Rvlimit'] : $params["configoption15"];
		 $backup_snapshot = $params['configoptions']['Backup Snapshot'] ? $params['configoptions']['Backup Snapshot'] : $params["configoption15"];
		 $backup_full = $params['configoptions']['Backupfull'] ? $params['configoptions']['Backupfull'] : $params["configoption16"];
		 $systemdisk = $params['configoptions']['SystemDisk'] ? $params['configoptions']['SystemDisk'] : $params["configoption23"];
		 //判断是否免费
		if($res["nextinvoicedate"]=='0000-00-00'){
			$res["nextinvoicedate"]='2099-01-01';
		}
		$status = ""; //升级不更改状态。

		$rsret = rstackKVM_edit_host($params["serverhostname"], $params["serveraccesshash"],$hostname,$cpu,$cpu_limit,$cpu_mode,$ram,$disk,$port,$ports,$bwlimit,$portmap,$binding_domain,$backup_snapshot,$backup_full,$status,$systemdisk);
		$ret = rstackKVM_CheckReturn($rsret);
		if ($ret["code"]=="0") {
			$rets = rstackKVM_CheckReturn(rstackKVM_start_virtual($params["serverhostname"], $params["serveraccesshash"], $res["subscriptionid"]));
			if ($rets["code"]=="-1"){
				return array('error' => $rets["msg"]);
			}
			return 'success';
		}else{
			return array('error' => $ret["msg"]);
		}
	 }

	 //修改原始密码
	 function rstackKVM_ChangePassword($params){
		$hostname = $params["domain"];
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
        $virtuals = json_decode(rstackKVM_search_virtual($params["serverhostname"],$params["serveraccesshash"],$res["subscriptionid"]));
		$param = rstackKVM_sign($params["serveraccesshash"]);
		$url = "http://".$params["serverhostname"]."/api/v3";
		$header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_resetps",
            "vmid"=>$res["subscriptionid"],
			"vmpass"=>$virtuals[0]->vmpass
        );
        $rsret = rstackKVM_post($url,$header,$data);
		$ret = rstackKVM_CheckReturn($rsret);
		if ($ret["code"]=="0") {
			return 'success';
		}else{
			return array('success' => $ret["msg"]);
		}
	 }
	 
	 	//编辑主机
	  function rstackKVM_edit_host($serverhostname,$apikey,$hostname,$cpu,$cpu_limit,$cpu_mode,$ram,$disk,$port,$ports,$bwlimit,$portmap,$binding_domain,$backup_snapshot,$backup_full,$status,$systemdisk)
	  {
		  $query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc");
		  $res = mysql_fetch_array($query);
		  $param = rstackKVM_sign($apikey);
		  $url = "http://".$serverhostname."/api/v3";
		  $header = array();
		  $data = array(
		    "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_update",
			"update_vm"=>"1", //立刻更改硬件(如果硬件一致 系统不会重启和更改)
            "id"=>$res["subscriptionid"], 
			"cpu"=>$cpu,
			"cpu_limit"=>$cpu_limit,
			"cpu_mode"=>$cpu_mode,
			"ram"=>$ram,
			"disk"=>$disk,
			"port"=>$port,
			"ports"=>$ports,
			"bwlimit"=>$bwlimit,
			"portmap"=>$portmap,
			"binding_domain"=>$binding_domain,
			"backup_snapshot"=>$backup_snapshot,
			"backup_full"=>$backup_full,
			"systemdisk"=>$systemdisk,
			"status"=>$status	//状态  续费的时候要吧状态改正常
		   );
		   return rstackKVM_post($url,$header,$data);
	  }
	  
	  
	function rstackKVM_ConfigOptions()
	{
		$servergroup = $_POST["servergroup"];
		if ($servergroup == "0") {
			return array("<span style=\"color:#008000;\">请选择服务器分组！</span>"=>array());
		}
		
		$query = mysql_query("SELECT * FROM tblservergroupsrel WHERE groupid=$servergroup");
		$res = mysql_fetch_array($query);
		$serverid = $res['serverid'];
		$query = mysql_query("SELECT * FROM tblservers WHERE id=" . $serverid . " and type='".moduleName."'");
		$res = mysql_fetch_array($query);
		
		$dataJson = json_decode(rstackKVM_list_area($res["hostname"], $res["accesshash"],""));
		
		$zones = [];
		if (count($dataJson)>0){
			$dataJson = rstackKVM_object_array($dataJson);
			$zones["0"] = "选择区域";
			foreach ($dataJson as $k => $v) {
				unset($dataJson[$k]);
				$zones[$v["id"]] = $v["name"];
			}
		}
		
		$dataJson2 = json_decode(rstackKVM_list_node($res["hostname"], $res["accesshash"],""));
		$node = [];
		
		if (count($dataJson2)>0){
			$dataJson2 = rstackKVM_object_array($dataJson2);
			$node["0"] = "选择节点";
			foreach ($dataJson2 as $k => $v) {
				unset($dataJson2[$k]);
				$node[$v["id"]] = $v["name"];
			}
		}
		
		$cpu_mode = [];
		$cpu_mode["0"] = "兼容模式";
		$cpu_mode["1"] = "隐藏模式";
		
		$cpu_percent = [];
		for ($i=0;$i<=100;$i++){
			$cpu_percent[$i]=$i;
		}
		
		$random_ip = [];
		$random_ip["1"] = "随机";
		$random_ip["0"] = "顺序";
		
		$random_remote_port = [];
		$random_remote_port["0"] = "不开启";
		$random_remote_port["1"] = "开启";
		
		$ip_mode = [];
		$ip_mode["0"] = "所有";
		$ip_mode["1"] = "开通独立IP云主机";
		$ip_mode["2"] = "开通共享IP云主机";
		
		$configarray = array(
				"区域" => array("Type" => "dropdown", "Size" => "5", "Options" => $zones, "Description" => "如不选请指定节点", "Default" => ""),         //1
				"计算节点" => array("Type" => "dropdown", "Size" => "5", "Options" => $node, "Description" => "如不选请指定区域(自动计算轮训开通或指定优先级开通)", "Default" => ""),         //2
				"镜像编号" => array("Type" => "text", "Size" => "5", "Description" => "镜像编号或为空时必须设置可配置选项,弹性镜像","Default" => "0"), //3
				"CPU核心" => array("Type" => "text", "Size" => "5", "Description" => "核 不超过计算节点最大数","Default" => "2"), //4
				"CPU基线" => array("Type" => "dropdown", "Size" => "5", "Options" => $cpu_percent, "Description" => "% (设置CPU基线控制,如50代表一半性能),0为不限制", "Default" => ""),//5
				"显示CPU" => array("Type" => "dropdown", "Size" => "5", "Options" => $cpu_mode, "Description" => "", "Default" => ""),         //6
				"内存" => array("Type" => "text", "Size" => "5", "Description" => "MB","Default" => "1024"), //7
				"数据盘" => array("Type" => "text", "Size" => "5", "Description" => "GB","Default" => "10"),//8
				"上行宽带" => array("Type" => "text", "Size" => "5", "Description" => "Mbps 最小1","Default" => "1"),//9
				"下行宽带" => array("Type" => "text", "Size" => "5", "Description" => "Mbps 最小1","Default" => "100"),//10
				"每月流量" => array("Type" => "text", "Size" => "5", "Description" => "GB （0为不限制）","Default" => "0"),//11
				"IP数量" => array("Type" => "text", "Size" => "5", "Description" => "个 （如果共享IP请为1）","Default" => "1"),//12
       		    "允许转发" => array("Type" => "text", "Size" => "5", "Description" => "条 （非NAT为0即可）","Default" => "0"),//13
				"允许建站" => array("Type" => "text", "Size" => "5", "Description" => "条 （非NAT为0即可）","Default" => "0"),//14
        	    //"允许重装" => array("Type" => "text", "Size" => "5", "Description" => "次 (每天允许最大次数)"),//15
				"快照数量" => array("Type" => "text", "Size" => "5", "Description" => "个","Default" => "0"),//15
				"备份数量" => array("Type" => "text", "Size" => "5", "Description" => "个","Default" => "0"),//16
				"IP开通方式" => array("Type" => "dropdown", "Size" => "5", "Options" => $random_ip, "Description" => "选择IP开通方式", "Default" => ""),//17
				"混合云模式" => array("Type" => "dropdown", "Size" => "5", "Options" => $ip_mode, "Description" => "适用于同节点混开独立IP云主机与共享IP云主机", "Default" => ""),//18
				"允许IPv6数量" => array("Type" => "text", "Size" => "5", "Description" => "如果节点不支持ipv6留空","Default" => "0"),//19
				"随机远程端口" => array("Type" => "dropdown", "Size" => "5", "Options" => $random_remote_port, "Description" => "", "Default" => ""),//20
				"系统磁盘读写IOPS" => array("Type" => "text", "Size" => "5", "Description" => " MB(为0不限制系统盘读写)","Default" => "0"),//21
				"数据磁盘读写IOPS" => array("Type" => "text", "Size" => "5", "Description" => " MB(为0不限制数据盘读写)","Default" => "0"),//22
				"系统盘扩容" => array("Type" => "text", "Size" => "5", "Description" => "如: 100,120前者win后者linux留空默认","Default" => "")//22
			);
		return $configarray;	
	}
	 
	 
	//变更RStack主控面板状态 overdue
	function rstackKVM_reset_virtual_status($serverhostname,$apikey,$vmid,$vm_state){
		$param = rstackKVM_sign($apikey);
		$url = "http://".$serverhostname."/api/v3";
		$header = array();
		$data = array(
		    "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_update",
			"status"=>$vm_state, //变更状态。主机状态（0=安装，1=锁定，2=正常，-1=中止，-2=超流量运行，-3=超流量停止）
            "id"=>$vmid
        );
		return rstackKVM_post($url,$header,$data);
	}
	
	//虚拟机开机
    function rstackKVM_start_virtual($serverhostname,$apikey,$vmid)
    {
		$param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_start",
            "vmid"=>$vmid
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	
	//根据主机名远程查询主机信息
	function rstackKVM_virtual_status($serverhostname,$apikey,$hostname)
    {
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_state",
            "vmid"=>$res["subscriptionid"]
        );
        return rstackKVM_post($url,$header,$data);
    }

	
	//获取列表快照
	function rstackKVM_list_snapshot($serverhostname,$apikey,$vmid)
    {
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvmbackup",
            "status"=>"1",
			"backuptype"=>"1",
			"order"=>"desc",
            "vmid"=>$vmid
        );
        $result = rstackKVM_post($url,$header,$data);
        if ($result ==""){
            $result = "[{\"isEmpty\":\"true\"}]";
        }
        return $result;
    }
	
	//操作快照
	function rstackKVM_operating_snapshot($serverhostname,$apikey,$hostname,$snapshotname,$subvaction){
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_snapshot",
			"subvaction"=>$subvaction,	// 参数：create,revert,del
            "vmid"=>$res["subscriptionid"],
         	"snapshotname"=>$snapshotname
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	function rstackKVM_list_backup($serverhostname,$apikey,$vmid)
    {
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvmbackup",
            "status"=>"1",
			"backuptype"=>"2",
			"order"=>"desc",
            "vmid"=>$vmid
        );
        //return rstackKVM_post($url,$header,$data);
         $result = rstackKVM_post($url,$header,$data);
        if ($result ==""){
            $result = "[{\"isEmpty\":\"true\"}]";
        }
        return $result;
    }
	
	//完整备份
	function rstackKVM_operating_backup($serverhostname,$apikey,$hostname,$backupname,$subvaction){
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_backup",
            "sign"=>$sign["sign"],
			"subvaction"=>$subvaction,	//参数：create,revert,del
            "vmid"=>$res["subscriptionid"],
         	"backupname"=>$backupname
        );
        return rstackKVM_post($url,$header,$data);
    }

	
	//查询指定主机的全部IP
	function rstackKVM_list_ip_address($serverhostname,$apikey,$vmid)
    {
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvmip",
			"iptype"=>"0",
            "vmid"=>$vmid
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	function rstackKVM_list_ipv6_address($serverhostname,$apikey,$vmid)
    {
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvmip",
			"iptype"=>"1",
            "vmid"=>$vmid
        );
        return rstackKVM_post($url,$header,$data);
    }
    
    function rstackKVM_binding_ip($serverhostname,$apikey,$vmid)
    {
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_setips",
            "vmid"=>$vmid
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	//获取转发公网IP
	function rstackKVM_nat_public_ip($serverhostname,$apikey,$vmid,$vip)
    {
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_exinfo",
         	"vmid"=>$vmid
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	
	//查询当前节点下可用的ISO
	function rstackKVM_list_iso($serverhostname,$apikey,$hostname)
    {
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
		$virtuals = json_decode(rstackKVM_search_virtual($serverhostname,$apikey,$res["subscriptionid"]));
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvmos",
            "osfile"=>"cd",
          	"nodeid"=>$virtuals[0]->nodeid
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	//主机允许安装的操作镜像
	function rstackKVM_list_template($serverhostname,$apikey,$hostname)
    {
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc ");
		$res = mysql_fetch_array($query);
		$virtuals = json_decode(rstackKVM_search_virtual($serverhostname,$apikey,$res["subscriptionid"]));
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvmos",
            "osfile"=>"os",
			"nodeid"=>$virtuals[0]->nodeid
        );
        $ret = rstackKVM_post($url,$header,$data);
        /*
        //允许安装镜像
		$packageid = $res["packageid"];
		$query2 = mysql_query("select * from tblproducts where id = $packageid");
		$res2 = mysql_fetch_array($query2);
		
		
		if ($res2["configoption20"] != ""){
			//$tmp  = explode(",",$res2["configoption20"]);
			$addJSON = "";
			$provinces = json_decode($ret, true);
			foreach($provinces as $province){
				$template_id = ",".$province['id'].",";
				if (strpos(",".$res2["configoption20"].",",$template_id) === false){
					continue;
				}else{
					//允许的镜像匹配成功
					$arr=array();
					$arr["id"] = $province['id'];
					$arr["name"] = $province['name'];
					$arr["template_name"] = $province['template_name'];
					$arr["system_type"] = $province['system_type'];
					$arr["type"] = $province['type'];
					$arr["remark"] = $province['remark'];
					$arr["sort"] = $province['sort'];
					$arr["time"] = $province['time'];
					$json0 =  json_encode($arr);
					if ($addJSON == ""){
						$addJSON .= $json0;
					}else{
						$addJSON .= ",".$json0;
					}
				}
			}
			$addJSON = "[".$addJSON."]";
			$ret = $addJSON;
		}
		*/
		return $ret;
    }
	
	//用户镜像ID查询镜像信息
	function rstackKVM_virtual_template($serverhostname,$apikey,$osid)
    {
		
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvmos",
			"id"=>$osid,
            "osfile"=>"os"
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	//NAT转发列表
	function rstackKVM_list_nat_acls($serverhostname,$apikey,$vmid)
    {
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvmnat",
          	"vmid"=>$vmid,
			"nattype"=>"1"
        );
        //return rstackKVM_post($url,$header,$data);
        $result = rstackKVM_post($url,$header,$data);
        if ($result ==""){
            $result = "[{\"isEmpty\":\"true\"}]";
        }
        return $result;
    }
	
	//NAT映射
	function rstackKVM_nat_acls($serverhostname,$apikey,$vmid,$portid,$privateport,$subvaction)
    {
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_portmap",
			"portid"=>$portid,
          	"vmid"=>$vmid,
			"privateport"=>$privateport,
         	"subvaction"=>$subvaction	//支持子类型 add,del (如删除只要提供portid即可)	
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	//NAT建站列表
	function rstackKVM_list_nat_webs($serverhostname,$apikey,$vmid)
    {
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvmnat",
          	"vmid"=>$vmid,
			"nattype"=>"2"
        );
        //return rstackKVM_post($url,$header,$data);
        $result = rstackKVM_post($url,$header,$data);
        if ($result ==""){
            $result = "[{\"isEmpty\":\"true\"}]";
        }
        return $result;
    }

	
	function rstackKVM_nat_webs($serverhostname,$apikey,$vmid,$domainid,$domainname,$privateport,$subvaction)
    {
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_domain",
            "domainid"=>$domainid,
          	"vmid"=>$vmid,
			"domainname"=>$domainname,
			"privateport"=>$privateport,
         	"subvaction"=>$subvaction //子类型：add,del
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	//电源。。
	function rstackKVM_virtual_power($serverhostname,$apikey,$hostname,$subaction)
    {
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc");
		$res = mysql_fetch_array($query);
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>$subaction,  //接口类型：kvm_start，kvm_restart，kvm_stop，kvm_force_restart，kvm_force_stop
            "vmid"=>$res["subscriptionid"]
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	//修改VNC密码
	function rstackKVM_resetvncps($serverhostname,$apikey,$hostname,$vncpass)
    {
        $query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc");
		$res = mysql_fetch_array($query);
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_resetvncps",
            "vmid"=>$res["subscriptionid"],
         	"vncpass"=>$vncpass
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	//修改系统密码
	function rstackKVM_resetps($serverhostname,$apikey,$hostname,$vmuser,$vmpass)
    {
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc");
		$res = mysql_fetch_array($query);
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_resetps",
            "vmid"=>$res["subscriptionid"],
            "vmuser"=>$vmuser,
         	"vmpass"=>$vmpass
        );
        return rstackKVM_post($url,$header,$data);
    }
	//重装系统
	function rstackKVM_reset_system($serverhostname,$apikey,$hostname,$osid,$rot)
    {
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc");
		$res = mysql_fetch_array($query);
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_reload",

            "vmid"=>$res["subscriptionid"],
         	"osid"=>$osid,
          	"rot"=>$rot //等于0只重装系统盘，等于1=全盘重装
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	
	//更改主机ISO
	function rstackKVM_change_cd_rom($serverhostname,$apikey,$hostname,$cdid,$subvaction){
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc");
		$res = mysql_fetch_array($query);
		$param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_cd_manage",
            "vmid"=>$res["subscriptionid"],
         	"cdid"=>$cdid, //cd镜像id（列表获取）-1为卸载vm光驱，否则请输入光驱id
          	"subvaction"=>$subvaction //change,list （更改，列表）
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	//监控生成曲线图
	function rstackKVM_kvm_monitor_view($serverhostname,$apikey,$hostname){
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc");
		$res = mysql_fetch_array($query);
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_monitor",
            "vmid"=>$res["subscriptionid"],
         	"yyyymmdd"=>"" //为空默认查询当日
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	function rstackKVM_login_vnc($serverhostname,$apikey,$hostname,$subvaction){
    	 //查询API主机ID
		$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname' order by id asc");
		$res = mysql_fetch_array($query);
		$param = rstackKVM_sign($apikey);
		$url = "http://".$serverhostname."/api/v3";
		$header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm_console",
            "vmid"=>$res["subscriptionid"],
         	"subvaction"=>$subvaction 
        );
        return rstackKVM_post($url,$header,$data);
        
    }
	
	//测试WHMCS和RStack面板通信
	function rstackKVM_TestConnection($params)
	{
		$data = rstackKVM_test($params["serverhostname"], $params["serveraccesshash"]);
		$ret = rstackKVM_CheckReturn($data);
		if ($ret["code"]=="0") {
			return array('success' => 'Test Success');
		} else {
			return array('error' => $ret["msg"]);
		}
	}
	
	 //测试连接
    function rstackKVM_test($domain,$apikey)
    {
        //$domain = "192.168.1.23:9999";
        $param = rstackKVM_sign($apikey);
		$url = "http://".$domain."/api/v3";
        $header = array();
		
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
            "api_language"=>"",
            "api_type"=>$param["api_type"],
            "action"=>"test"
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	
	//区域搜索
    function rstackKVM_list_area($domain,$apikey,$areaid)
    {
		$param = rstackKVM_sign($apikey);
		$url = "http://".$domain."/api/v3";
        $header = array();
		//参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"id"=>$areaid,
			"label"=>$param["api_type"],
          	"api_type"=>$param["api_type"],
          	"action"=>"area"
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	//节点搜索
    function rstackKVM_list_node($domain,$apikey,$nodeid)
    {
		$param = rstackKVM_sign($apikey);
		$url = "http://".$domain."/api/v3";
        $header = array();
		//参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
            "api_type"=>$param["api_type"],
			"id"=>$nodeid,
          	"action"=>"kvmnode"
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	//根据主机名远程查询主机信息
	function rstackKVM_search_virtual($serverhostname,$apikey,$vmid)
    {
        $param = rstackKVM_sign($apikey);
        $url = "http://".$serverhostname."/api/v3";
        $header = array();
        //参数
        $data = array(
            "api_sign"=>$param["api_sign"],
            "api_random"=>$param["api_random"],
            "api_timestamp"=>$param["api_timestamp"],
			"api_type"=>$param["api_type"],
			"action"=>"kvm",
            "id"=>$vmid
        );
        return rstackKVM_post($url,$header,$data);
    }
	
	
	//客户端页输出
	function rstackKVM_ClientArea($params){
		 if ($params["status"] != "Completed" and $params["status"] != "Active") {
			return 0;
		} else {
			function arg($name = null, $default = null, $trim = false)
			{
				if ($name) {
					if (!isset($_REQUEST[$name])) return $default;
					$arg = $_REQUEST[$name];
					if ($trim) $arg = trim($arg);
				} else {
					$arg = $_REQUEST;
				}
				return $arg;
			}
			
			$post = arg();
           
			$data[] = "";
			
			$hostname_ = $params["domain"];
			$query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$hostname_' order by id asc");
			$res = mysql_fetch_array($query);
			
			$host = json_decode(rstackKVM_search_virtual($params["serverhostname"], $params["serveraccesshash"], $res["subscriptionid"]));
           
			switch ($post["a"]) {
				case "virtual_status":
                	exit(rstackKVM_virtual_status($params["serverhostname"], $params["serveraccesshash"], $params["domain"]));
                	break;
				case "list_virtual":
                	//header('Content-Type:application/json; charset=utf-8');
                	$result = rstackKVM_search_virtual($params["serverhostname"], $params["serveraccesshash"], $res["subscriptionid"]);
                	exit($result);
					break;
                case "virtual_power"://电源，支持kvm_start，kvm_restart，kvm_stop，kvm_force_restart，kvm_force_stop
                	$result = rstackKVM_virtual_power($params["serverhostname"], $params["serveraccesshash"], $params["domain"],$post["subaction"]);
                	exit($result);
                	break;
                case "resetvncps":
                    $result = rstackKVM_resetvncps($params["serverhostname"], $params["serveraccesshash"], $params["domain"],$post["vncpass"]);
                	exit($result);
                	break;
				case "ip_address":
					$result =  rstackKVM_list_ip_address($params["serverhostname"], $params["serveraccesshash"], $host[0]->id);
					exit($result);
                	break;
                case "ipv6_address":
					$result =  rstackKVM_list_ipv6_address($params["serverhostname"], $params["serveraccesshash"], $host[0]->id);
					exit($result);
                	break;
                case "binding_ip":
					$result =  rstackKVM_binding_ip($params["serverhostname"], $params["serveraccesshash"], $host[0]->id);
					exit($result);
                	break;	
				case "nat_public_ip":
					$result =  rstackKVM_nat_public_ip($params["serverhostname"], $params["serveraccesshash"], $host[0]->id,$host[0]->ip);
					exit($result);
                	break;
                case "resetps": //重置系统密码
                	$result = rstackKVM_resetps($params["serverhostname"], $params["serveraccesshash"], $params["domain"],$post["vmuser"],$post["vmpass"]);
                	exit($result);
                	break;
                case "reset_system"://重装系统  重置类型：0=格式化C盘，1=全盘格式化
                	$result = rstackKVM_reset_system($params["serverhostname"], $params["serveraccesshash"], $params["domain"],$post["osid"],$post["rot"]);
                	exit($result);
                	break;
                case "snapshot": //操作快照 类型支持参数：create,revert,delete
                     $result = rstackKVM_operating_snapshot($params["serverhostname"], $params["serveraccesshash"], $params["domain"],$post["snapshotname"],$post["subvaction"]);
                     exit($result);
                      break;
                case "backup"://操作备份 类型参数：create,revert,delete
                     $result = rstackKVM_operating_backup($params["serverhostname"], $params["serveraccesshash"], $params["domain"],$post["backupname"],$post["subvaction"]);
                     exit($result);
                     break;
                case "list_template": //根据主机名 列出当前节点中可用的镜像列表
                	$result = rstackKVM_list_template($params["serverhostname"], $params["serveraccesshash"], $params["domain"]);
                    exit($result);
                    break;
				case "list_iso":
					$result = rstackKVM_list_iso($params["serverhostname"], $params["serveraccesshash"], $params["domain"]);
                    exit($result);
                    break;
				case "list_snapshot":
					$result = rstackKVM_list_snapshot($params["serverhostname"], $params["serveraccesshash"],$host[0]->id);
                    exit($result);
                    break;
				case "list_backup":
					$result = rstackKVM_list_backup($params["serverhostname"], $params["serveraccesshash"],$host[0]->id);
                    exit($result);
                    break;
				case "list_nat_acls":
					$result = rstackKVM_list_nat_acls($params["serverhostname"], $params["serveraccesshash"],$host[0]->id);
                    exit($result);
                    break;
				case "nat_acls":
					$result = rstackKVM_nat_acls($params["serverhostname"], $params["serveraccesshash"],$host[0]->id,$post["portid"],$post["privateport"],$post["subvaction"]);
                    exit($result);
                    break;
				case "list_nat_webs":
					$result = rstackKVM_list_nat_webs($params["serverhostname"], $params["serveraccesshash"],$host[0]->id);
                    exit($result);
                    break;
				case "nat_webs":
					$result = rstackKVM_nat_webs($params["serverhostname"], $params["serveraccesshash"],$host[0]->id,$post["domainid"],$post["domainname"],$post["privateport"],$post["subvaction"]);
                    exit($result);
                    break;
                case "change_cd_rom": //编辑ISO镜像 类型：mount,umount
                	$result = rstackKVM_change_cd_rom($params["serverhostname"], $params["serveraccesshash"], $params["domain"],$post["cdid"],$post["subvaction"]);
                    exit($result);
                    break;
                case "kvm_monitor_view": //KVM图表 默认查看今天数据 ,外部调用 默认请为0 查今天统计数据
                	$result = rstackKVM_kvm_monitor_view($params["serverhostname"], $params["serveraccesshash"], $params["domain"]);
                    exit($result);
                    break;
                case "login_vnc":
                	$result=rstackKVM_login_vnc($params["serverhostname"], $params["serveraccesshash"], $params["domain"], $post["subvaction"]);
                	/* $novnc_viewer = file_get_contents('modules/servers/rstack/novnc.html');
                	echo $novnc_viewer = vlang_vars_name($novnc_viewer, array(
                        'url' => $url
                        )
                    ); */
					//header("Location: ".$url);
					exit($result);
                    break;
				case "kvm_control":
					switch ($vtype){
						case "reset_system":
							$result = rstackKVM_reset_system($params["serverhostname"], $params["serveraccesshash"], $params["domain"],$post["osid"],$post["rot"]);
							exit($result);
							break;
						
					}
				default: //默认输出页面。
               /*  $data = array(
						'tabOverviewReplacementTemplate' => 'clientarea'
						//'templateVariables'              => array('status' => \WHMCS\Database\Capsule::table('tblhosting')->where('id', $vars['serviceid'])->first()->notes)
					); */
					break;
			}
			
           
          
           
           //根据当前主机对应计算节点查询
           $nodes =json_decode(rstackKVM_list_node($params["serverhostname"], $params["serveraccesshash"], $host[0]->nodeid));
           
           ////根据当前主机对应计算节点查询
           $zones =json_decode(rstackKVM_list_area($params["serverhostname"], $params["serveraccesshash"], $host[0]->areaid));
           
           $ip_address =  rstackKVM_object_array(json_decode(rstackKVM_list_ip_address($params["serverhostname"], $params["serveraccesshash"], $host[0]->id)));
           $ipv6_address =  rstackKVM_object_array(json_decode(rstackKVM_list_ipv6_address($params["serverhostname"], $params["serveraccesshash"], $host[0]->id)));
           $mainip = json_decode(rstackKVM_search_virtual($params["serverhostname"], $params["serveraccesshash"], $host[0]->id));
           //加载云主机可用的ISO镜像
           $list_iso = rstackKVM_object_array(json_decode(rstackKVM_list_iso($params["serverhostname"], $params["serveraccesshash"], $host[0]->hostname)));
           
           //转发列表
           $nat_acls =rstackKVM_object_array(json_decode(rstackKVM_list_nat_acls($params["serverhostname"], $params["serveraccesshash"], $host[0]->id)));
		   $nat_webs =rstackKVM_object_array(json_decode(rstackKVM_list_nat_webs($params["serverhostname"], $params["serveraccesshash"], $host[0]->id)));
		   
		   $virtual_template = json_decode(rstackKVM_virtual_template($params["serverhostname"], $params["serveraccesshash"], $host[0]->osid));
		   
           $host_name_0 = $params["domain"]; 
           $query = mysql_query("SELECT * FROM tblhosting WHERE domain ='$host_name_0' order by id asc ");
		   $tblhosting = mysql_fetch_array($query);
           
        
           
            return [
            'tabOverviewReplacementTemplate' => 'clientarea',
			//'templatefile' => 'clientarea',
            'vars' => [  
              	'tblhosting' => $tblhosting,
				'virtuals' => $host,
                'nodes' => $nodes,
                'zones' => $zones,
                'params' => $params,
                'host' => $host,
				'virtual_template' => $virtual_template,
                'ip_address' => $ip_address, //$mainip
                'ipv6_address' => $ipv6_address, //$mainip
              	'mainip' => $mainip[0]->ip, //首个IP
              	'nat_acls' => $nat_acls,
				'nat_webs' => $nat_webs,
                'showcpu' => $showcpu, //返回当前已安装镜像
              	'list_iso' => $list_iso //列出当前虚拟机 可用的ISO镜像
            ]
        ];
            
		}
		//return $data;
	}
	
	//验证是否整数
	function rstackKVM_isnumber($str){
		$result = false;
		if(preg_match("/^[0-9]+$/" ,$str)){
			$result = true;
		}
		return $result;
	}
	
	function rstackKVM_object_array($array)
	{
		if (is_object($array)) {
			$array = (array)$array;
		}
		if (is_array($array)) {
			foreach ($array as $key => $value) {
				$array[$key] = rstackKVM_object_array($value);
			}
		}
		return $array;
	}
	
	function rstackKVM_CheckReturn($str){
		$tmp  = explode("|",$str);
		if (count($tmp)>2){
			return array(
				"code"=>"-1",
				"msg"=>"API返回格式不能出现多个|符号",
			);
		}else if (count($tmp) == 2){
			//带返回值 格式如  0|success
			return array(
				"code"=>$tmp[0],
				"msg"=>$tmp[1],
			);
		}else{
			if ($str == "0"){
				// 只返回 0 的接口
				return array(
					"code"=>$str,
					"msg"=>"",
				);
			}else{
				// 返回错误信息
				return array(
					"code"=>$tmp[0],
					"msg"=>$tmp[1],
				);
			}
		}
	}
	
	function rstackKVM_CheckReturnJSON($str){
		$tmp  = explode("|",$str);
		if (count($tmp)>2){
			return array(
				"code"=>"-1",
				"msg"=>"API返回格式不能出现多个|符号",
			);
		}else if (count($tmp) == 2){
			//带返回值 格式如  0|success
			return array(
				"code"=>$tmp[0],
				"msg"=>$tmp[1],
			);
		}else{
				return array(
					"code"=>"0",
					"msg"=>"success",
					"data"=>$str,
				);
		}
	}
	
	function rstackKVM_sign($apikey)
    {
        $api_timestamp = time();
		$api_random = rstackKVM_GetRandStr(16);
        //加密MD5
		$api_sign = md5($apikey.$api_random.$api_timestamp);
        //返回sign签名
        return array(
            "api_sign"=>$api_sign,
            "api_timestamp"=>$api_timestamp,
            "api_random"=>$api_random,
            "api_language"=>"chinese",
            "api_type"=>virtualType
        );
    }
	

     // 发送POST请求
    function rstackKVM_post($url,$header,$data){
        $cUrl = curl_init();
        curl_setopt($cUrl, CURLOPT_URL, $url);//目标URL
        curl_setopt($cUrl, CURLOPT_TIMEOUT,600);//超时时间
        curl_setopt($cUrl, CURLOPT_POST, true);	//POST请求
        curl_setopt($cUrl, CURLOPT_POSTFIELDS, http_build_query($data));//POST数据
        curl_setopt($cUrl, CURLOPT_RETURNTRANSFER, 1);//设置接收返回值
        curl_setopt($cUrl, CURLOPT_HTTPHEADER, $header);//请求头
        curl_setopt($cUrl, CURLOPT_HEADER, true);//请求头
        curl_setopt($cUrl, CURLOPT_SSL_VERIFYPEER, FALSE);//不验证证书
        curl_setopt($cUrl, CURLOPT_SSL_VERIFYHOST, FALSE);//不验证HOSTS
        $output = curl_exec($cUrl); //发送
        $headerSize = curl_getinfo($cUrl, CURLINFO_HEADER_SIZE);//获取响应头长度
        $body = substr($output, $headerSize); //获取内容
        curl_close($cUrl);//释放curl资源
        return $body;
    }
    
    function rstackKVM_GetRandStr($length){
        $str = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789';
        $len = strlen($str)-1;
        $randstr = '';
        for ($i=0;$i<$length;$i++) {
            $num=mt_rand(0,$len);
            $randstr .= $str[$num];
        }
        return $randstr;
    }

	

	
		/*
	支持模块函数
	function rstackKVM_ConfigOptions()
	function rstackKVM_CreateAccount($params)
	function rstackKVM_TerminateAccount($params)
	function rstackKVM_SuspendAccount($params)
	function rstackKVM_UnsuspendAccount($params)
	function rstackKVM_ChangePassword($params)
	function rstackKVM_ChangePackage($params)
	function rstackKVM_ClientArea($params)
	function rstackKVM_AdminLink($params)
	function rstackKVM_LoginLink($params)
	function rstackKVM_genkey($params)
	function rstackKVM_uninstall($params)
	function rstackKVM_ClientAreaCustomButtonArray()
	function rstackKVM_AdminCustomButtonArray() {.
	function rstackKVM_extrapage($params)
	function rstackKVM_UsageUpdate($params)
	function rstackKVM_AdminServicesTabFields($params)
	function rstackKVM_AdminServicesTabFieldsSave($params)
	*/
	/*
        RStack云平台，复制请保留版权：http://www.rstack.com.cn/
    */
	